package envoy.client;

import java.util.function.Function;

/**
 * Project: <strong>envoy-clientChess</strong><br>
 * File: <strong>ConfigItem.javaEvent.java</strong><br>
 * Created: <strong>21.12.2019</strong><br>
 * 
 * @author Kai S. K. Engelbart
 */
public class ConfigItem<T> {

	private String				commandLong, commandShort;
	private Function<String, T>	parseFunction;
	private T					value;

	public ConfigItem(String commandLong, String commandShort, Function<String, T> parseFunction, T defaultValue) {
		this.commandLong	= commandLong;
		this.commandShort	= commandShort;
		this.parseFunction	= parseFunction;
		value				= defaultValue;
	}

	public void parse(String input) { value = parseFunction.apply(input); }

	public String getCommandLong() { return commandLong; }

	public String getCommandShort() { return commandShort; }

	public T get() { return value; }
}
